#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "Point.h"
#include "PointList.h"

int point_compare(const void* a1, const void* a2) ; 

PointList* read_list(char* filename)
{
  FILE* f = fopen(filename,"r");

  PointList* p = NULL; 
  PointList *end,*prev; 
  Point* buf=NULL; 
  int l,n=0;

  if (f==NULL) 
  {
    fprintf(stderr,"Can't open <%s> - quitting\n",filename);
    exit(1);
  }

  prev=NULL;
  do
  {
    buf = realloc(buf,sizeof(Point)*(n+1));
    l = read_point(f,buf+n); 
    if (l)
    {
      if (p==NULL) // First point
      {
        p=malloc(sizeof(PointList)); 
        p->prev=NULL;
        end=p; 
      }
      else
      {
        end->prev=prev;
        prev=end; 
        end->next=malloc(sizeof(PointList));
        end=end->next;
      }
      end->next = NULL;
      n++;
    }
    else  // last point - link prev pointer
    {
      end->prev = prev;
    }
  }
  while (l); 

// qsort the y-co-ordinate
  qsort(buf,n,sizeof(Point),point_compare);

// now link onto point array
  end=p;
  n=0;
  while (end!=NULL)
  {
    end->point = buf+n; n++;
    end=end->next;
  }

  fclose(f);
  return p; 
}

void print_loop(PointList* p)
{ 
  PointList *start=p; // re-print the first point again to make a loop
  if (p != NULL) 
  {
    do
    {
      printf("%lf %lf\n",p->point->x,p->point->y);
      p=p->next;
    }
    while (p!=NULL); 
    printf("%lf %lf\n",start->point->x,start->point->y);
  }
}

